;************************************
; Dex entry
; Entry for the 512b compo 2009.
; A Bootable CdPlayer with clock.
;
; Assemble with fasm 
; c:\fasm Player.asm Player.bin
;
; Use Partcopy Player.bin 0 200 -f0
; Make sure you have a empty flppy in A:
;
;************************************
org 0x7C00
use16
;****************************
; Realmode startup code.
;****************************
start:
	xor   ax,ax
	mov   ds,ax
	mov   es,ax
	mov   ss,ax
	mov   sp,0x7C00
;****************************
; Print Menu.
;****************************
	call  cls
	mov   si,Msg1
	call  print_string
;****************************
; Hide's cursor
;****************************
	mov   ah,01h
	mov   cx,2000h
	int   10h
;*******************************************
; UpDate time
;*******************************************
do_pass_go:
	pusha
	mov   ah,2
	int   1ah
	push  cx
	push  dx
	pop   eax
m1:
	mov   al,163
	sub   dl,160
	ja    $+3
	rol  eax,4
	push  ax
	mov   ah,0eh
	int   10h
	pop   ax
	jne   m1
	mov   ah,02h
	mov   dl,7
	mov   dh,8
	int   10h
	popa
	hlt
	xor   ax,ax
	in    al,60h
	cmp   al,0x62
	jb    do_pass_go
;*******************************************
; Cdplayer key input 
;*******************************************
	xor ax,ax
	int 16h
	cmp   al,'p'
	jne   @f
	call  Play_cd
@@:
	cmp   al,'P'
	jne   @f
	call  Play_cd
@@:
	cmp   al,'S'
	jne   @f
	call  Stop_cd
@@:
	cmp   al,'s'
	jne   @f
	call  Stop_cd
@@:
	cmp   al,'O'
	jne   @f
	call  Eject_cd
@@:
	cmp   al,'o'
	jne   @f
	call  Eject_cd
@@:
	cmp   al,'C'
	jne   @f
	call  Close_cd
@@:
	cmp   al,'c'
	jne   @f
	call  Close_cd
@@:
	mov   ah,0x05
	mov   ch,0x61
	mov   cl,0x1e
	int   16h
	jmp   do_pass_go
;****************************
; Play_cd.
;****************************
Play_cd:
	pusha
	mov   si,packet2
	mov   byte[ds:si+1],1
	mov   byte[ds:si+4],1
	call  Send_Atapi_Packet
	mov   si,packet1
	call  Send_Atapi_Packet
	popa
	ret
;****************************
; Close_cd
;****************************
Close_cd:
	pusha
	mov   si,packet2
	mov   byte[ds:si+1],1
	mov   byte[ds:si+4],3
	call  Send_Atapi_Packet
	popa
	ret
;****************************
; Eject_cd
;****************************
Eject_cd:
	pusha
	mov   si,packet2
	mov   byte[ds:si+1],1
	mov   byte[ds:si+4],2
	call  Send_Atapi_Packet
	popa
	ret
;****************************
; Stop_cd
;****************************
Stop_cd:
	pusha
	mov   si,packet2
	mov   byte[ds:si+1],0
	mov   byte[ds:si+4],0
	call  Send_Atapi_Packet
	popa
	ret
;*******************************************
; print string         
;*******************************************
print_string:
	cld
Cycle:
	lodsb
	or    al,al
	jz    Done
	call  print_char
	jmp   Cycle
Done:
	ret
;*******************************************
; print char         
;*******************************************
print_char:
	mov   ah,0eh
	int   10h
	ret
;*******************************************
; Clear screen       
;*******************************************
cls:
	mov   ah,0Fh 
	int   10h
	mov   ah,0
	int   10h
	ret
;*******************************************
; some data    
;*******************************************
Msg1:	db 13,10,' Bootable CdPlayer, by Dex.',13,10,10
	db	 '  P = Play  CD.',13,10
	db	 '  S = Stop  CD.',13,10
	db	 '  O = Open  CD.',13,10
	db	 '  C = Close CD.',13,10,10
	db	 ' Time  ',0
;***********************************
; Include file for atapi driver.
;***********************************
include 'Ata_Atapi.inc'
packet1:
	db 0x45
	db 0x0
	db 0x0
	db 0x0
	db 0x0
	db 0x0
	db 0x0
	db 0xff
	db 0xff
packet2:				;3=close,2=eject,1=start,0=stop
	db 0x1b
	db 0x0
	db 0x0
	db 0x0
	db 0x0
;*************************************
; Make program 510 byte's + 0xaa55
;*************************************
times 510- ($-start)  db 0
dw 0xaa55

