#!/usr/bin/ksh

ERR_LOG=./out.txt   #		/dev/null
FILE=./testresults.log

fromdos -b -l${ERR_LOG} $*
cat $* | tr '\000' ' ' | grep -a ^ts >  ${FILE}

nb_tot=`wc -l < ${FILE} 2> ${ERR_LOG}`
nb_succ=`grep Ok < ${FILE} 2> ${ERR_LOG} | wc -l` 
pct_success=`expr 100 \* ${nb_succ} / ${nb_tot}` 
nb_fail=`expr ${nb_tot} - ${nb_succ}`  

nb_suites=`cat ${FILE} 2> ${ERR_LOG} | cut -d \; -f 1 | sort -u | wc -l` 
nb_tests=`cat ${FILE} 2> ${ERR_LOG} | cut -d \; -f 2 | sort -u | wc -l` 

echo '----'
echo '* All test results'
cat ${FILE}
echo '----'
echo '* '"${nb_suites} test suites"
echo '* '"${nb_tests} tests ${nb_succ} succeed ${nb_fail} failed"
echo '* '"${pct_success} percent success"
echo ''
echo '----'
echo '* '"${nb_fail} failed tests :"
echo ''
grep Ko < ${FILE} 2> ${ERR_LOG} | sort
echo ''

