%include "unit.inc"

BUF_ADR equ	0x0A00

%include "picoforth.mac"

test_suite:
	call ut_interp_test1


	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "ts_key;", "$"
ncrlf2:		db 13, 10, "$"

nbr:	dw 0

l_keybuf:	db "abc",0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 1

ntest1:		db "tst_key_a;", "$"
;;

expected1	equ "a"

ut_interp_test1:
	mov si, ut_thread1
	NEXT
ut_thread1:
	dw init_kbuf, l_keybuf
	dw get_char
	dw store_key
	dw cmp_char, expected1
	dw prim_skip_zero
	dw ut_test1_ok
	dw ut_test1_ko
	dw outer_quit

cmp_char:
	lodsw
	cmp bx, ax
	jne not_equal
	mov bx, 1
	NEXT		;; --> exit point
not_equal:
	mov bx, 0
	NEXT

ut_test1_ko:
	puts nsuite
	puts ntest1
	puts nko2
	jmp ut_print_result1
	ret

ut_test1_ok:
	puts nsuite
	puts ntest1
	puts nok2

ut_print_result1:
	puts nexpected
	putw expected1
	puts nobtained
	putw word [key]
	puts ncrlf2
	ret

key:	dw 0

store_key:
	mov word [key], bx
	NEXT
	
;-----------------------------------------------------------------------------
;

set_current:
	mov word [current_sector], bx
	NEXT


ut_lit:
	lodsw
	mov bx, ax
	NEXT



one_tos:
	mov bx, 1
	NEXT
raz_tos:
	mov bx, 0
	NEXT

nko2:	db "Ko;","$"
nok2:	db "Ok;","$"

tst_raz:
	mov bx, 0
	mov word [nbr], bx
	NEXT

tst_inc:
	mov bx, word [nbr]
	inc bx
	mov word [nbr], bx
	NEXT

tst_expected equ 1

tst_comp:
	mov bx, 0
	mov ax, word [nbr]
	cmp ax, tst_expected
	je tst_fin
	mov bx, 1
tst_fin:
	NEXT



%include "picotable.inc"
%include "picoforth.inc"
%include "fakehw.inc"
