%include "unit.inc"

BUF_ADR equ	0x0A00

%include "picoforth.mac"

test_suite:
	call ut_interp_test1
	call ut_interp_test2
	call ut_interp_test3b
	call ut_interp_test3
	call ut_interp_test4


	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "ts_prt;", "$"
ncrlf2:		db 13, 10, "$"

nbr:	dw 0


%macro str_compare 2
	push si
	mov si, %1
	mov al, 0
	mov cx, 0xFFFF
	rep scasb
	mov cx, si
	sub ax, %1
	mov cx,ax
	mov si, %1
	mov di, %2
	repe cmpsb
	jne %%cmp_neq
	mov bx, 0
	jmp %%cmp_end
%%cmp_neq:
	mov bx, 1
%%cmp_end:
	pop si
%endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 1

ntest1:		db "tst_cmp_aa;", "$"
;;

str1:	db "abcdef",0


ut_interp_test1:
	mov si, ut_thread1
	NEXT
ut_thread1:
	dw cmp_self
	dw prim_skip_zero
	dw ut_test1_nok
	dw ut_test1_ok
	dw outer_quit

cmp_self:
	str_compare str1, str1	
	NEXT

ut_test1_nok:
	puts nsuite
	puts ntest1
	puts nko2
	puts ncrlf2
	ret

ut_test1_ok:
	puts nsuite
	puts ntest1
	puts nok2
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 2

ntest2:		db "tst_cmp_ab;", "$"

str2a:	db "abcdef",0
str2b:	db "abcghi",0


ut_interp_test2:
	mov si, ut_thread2
	NEXT
ut_thread2:
	dw ut_test2_test
	dw prim_skip_zero
	dw ut_test2_ok
	dw ut_test2_nok
	dw outer_quit

ut_test2_test:
	str_compare str2a, str2b
	NEXT

ut_test2_nok:
	puts nsuite
	puts ntest2
	puts nko2
	puts ncrlf2
	ret

ut_test2_ok:
	puts nsuite
	puts ntest2
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 3

ntest3:		db "tst_prim_print;", "$"

str3:	db "abcdef",0,"$"


ut_interp_test3:
	mov si, ut_thread3
	NEXT
ut_thread3:
	dw raz_buf
	dw prim_print, str3
	dw put_zero
	dw ut_test3_test
	dw prim_skip_zero
	dw ut_test3_ok
	dw ut_test3_nok
	dw outer_quit

ut_test3_test:
	str_compare str3, out_buf
	NEXT

ut_test3_nok:
	puts nsuite
	puts ntest3
	puts nko2
	jmp ut_result3
	ret

ut_test3_ok:
	puts nsuite
	puts ntest3
	puts nok2
ut_result3:
	puts nexpected
	puts str3
	puts nobtained
	puts out_buf
	puts ncrlf2
	ret

raz_buf:
	mov byte[len],0
	mov cx,255
	mov ax, 0
	mov di, out_buf
	rep stosb
	NEXT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 3b

ntest3b:		db "tst_raz_buf;", "$"

str3b:	db 0,"$"


ut_interp_test3b:
	mov si, ut_thread3b
	NEXT
ut_thread3b:
	dw raz_buf
	dw put_zero
	dw ut_test3b_test
	dw prim_skip_zero
	dw ut_test3b_ok
	dw ut_test3b_nok
	dw outer_quit

ut_test3b_test:
	str_compare str3b, out_buf
	NEXT

ut_test3b_nok:
	puts nsuite
	puts ntest3b
	puts nko2
	jmp ut_result3b
	ret

ut_test3b_ok:
	puts nsuite
	puts ntest3b
	puts nok2
ut_result3b:
	puts nexpected
	puts str3b
	puts nobtained
	puts out_buf
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 4

ntest4:		db "tst_print_current == 0;", "$"

str4:	db "0","$"


ut_interp_test4:
	mov si, ut_thread4
	NEXT
ut_thread4:
	dw raz_buf
	dw ut_lit, 0
	dw set_current
	dw prim_print_current
	dw put_zero
	dw ut_test4_test
	dw prim_skip_zero
	dw ut_test4_ok
	dw ut_test4_nok
	dw outer_quit

ut_test4_test:
	str_compare str4, out_buf
	NEXT

ut_test4_nok:
	puts nsuite
	puts ntest4
	puts nko2
	jmp ut_result4
	ret

ut_test4_ok:
	puts nsuite
	puts ntest4
	puts nok2
ut_result4:
	puts nexpected
	puts str4
	puts nobtained
	puts out_buf
	puts ncrlf2
	ret


;-----------------------------------------------------------------------------
;

set_current:
	mov word [current_sector], bx
	NEXT


ut_lit:
	lodsw
	mov bx, ax
	NEXT



one_tos:
	mov bx, 1
	NEXT
raz_tos:
	mov bx, 0
	NEXT

nko2:	db "Ko;","$"
nok2:	db "Ok;","$"

tst_raz:
	mov bx, 0
	mov word [nbr], bx
	NEXT

tst_inc:
	mov bx, word [nbr]
	inc bx
	mov word [nbr], bx
	NEXT

tst_expected equ 1

tst_comp:
	mov bx, 0
	mov ax, word [nbr]
	cmp ax, tst_expected
	je tst_fin
	mov bx, 1
tst_fin:
	NEXT

	


%include "picotable.inc"
%include "picoforth.inc"
%include "fakehw.inc"
