%include "unit.inc"

BUF_ADR equ	0x0A00

%include "picoforth.mac"

test_suite:
	call ut_interp_test01
	call ut_interp_test02

	call ut_interp_test03
	call ut_interp_test04
	call ut_interp_test05
	call ut_interp_test06
	call ut_interp_test07
	call ut_interp_test08
	call ut_interp_test09

	call ut_interp_test13
	call ut_interp_test14
	call ut_interp_test15
	call ut_interp_test16
	call ut_interp_test17
	call ut_interp_test18
	call ut_interp_test19

	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "ts_sct;", "$"
ncrlf2:		db 13, 10, "$"

nbr:	dw 0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 01

ntest01:	db "tst_set_current 125;", "$"

expected_01	equ 125


ut_interp_test01:
	mov si, ut_thread01
	NEXT
ut_thread01:
	dw ut_lit, expected_01
	dw set_current
	dw ut_test01
	dw prim_skip_zero
	dw ut_test01_ok
	dw ut_test01_nok
	dw outer_quit

ut_test01:
	mov bx, word [current_sector]
	cmp bx, expected_01
	je test_01_equal
	mov bx, 0
	jmp test_01_end
test_01_equal:
	mov bx, 1
test_01_end:
	NEXT

ut_test01_nok:
	puts nsuite
	puts ntest01
	puts nko2
	jmp ut_result01
	ret

ut_test01_ok:
	puts nsuite
	puts ntest01
	puts nok2
ut_result01:
	puts nexpected
	putw expected_01
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 02

ntest02:	db "tst_set_current 17;", "$"

expected_02	equ 17


ut_interp_test02:
	mov si, ut_thread02
	NEXT
ut_thread02:
	dw ut_lit, expected_02
	dw set_current
	dw ut_test02
	dw prim_skip_zero
	dw ut_test02_ok
	dw ut_test02_nok
	dw outer_quit

ut_test02:
	mov bx, word [current_sector]
	cmp bx, expected_02
	je test_02_equal
	mov bx, 0
	jmp test_02_end
test_02_equal:
	mov bx, 1
test_02_end:
	NEXT

ut_test02_nok:
	puts nsuite
	puts ntest02
	puts nko2
	jmp ut_result02
	ret

ut_test02_ok:
	puts nsuite
	puts ntest02
	puts nok2
ut_result02:
	puts nexpected
	putw expected_02
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 03

ntest03:	db "tst_0_next_1;", "$"

expected_03	equ 1


ut_interp_test03:
	mov si, ut_thread03
	NEXT
ut_thread03:
	dw ut_lit, 0
	dw set_current
	dw outer_next_sct
	dw ut_test03
	dw prim_skip_zero
	dw ut_test03_ok
	dw ut_test03_nok
	dw outer_quit

ut_test03:
	mov bx, word [current_sector]
	cmp bx, expected_03
	je test_03_equal
	mov bx, 0
	jmp test_03_end
test_03_equal:
	mov bx, 1
test_03_end:
	NEXT

ut_test03_nok:
	puts nsuite
	puts ntest03
	puts nko2
	jmp ut_result03
	ret

ut_test03_ok:
	puts nsuite
	puts ntest03
	puts nok2
ut_result03:
	puts nexpected
	putw expected_03
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 04

ntest04:	db "tst_200_next_1;", "$"

ut_interp_test04:
	mov si, ut_thread04
	NEXT
ut_thread04:
	dw ut_lit, SCT_MAX
	dw set_current
	;dw outer_next_sct
	dw change_sector, 1
	dw ut_test04
	dw prim_skip_zero
	dw ut_test04_ok
	dw ut_test04_nok
	dw outer_quit

ut_test04:
	mov bx, word [current_sector]
	cmp bx, SCT_MIN
	je test_04_equal
	mov bx, 0
	jmp test_04_end
test_04_equal:
	mov bx, 1
test_04_end:
	NEXT

ut_test04_nok:
	puts nsuite
	puts ntest04
	puts nko2
	jmp ut_result04
	ret

ut_test04_ok:
	puts nsuite
	puts ntest04
	puts nok2
ut_result04:
	puts nexpected
	putw SCT_MIN
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 05

ntest05:	db "tst_0_next_10;", "$"

expected_05	equ 10


ut_interp_test05:
	mov si, ut_thread05
	NEXT
ut_thread05:
	dw ut_lit, 0
	dw set_current
	dw outer_next_10
	dw ut_test05
	dw prim_skip_zero
	dw ut_test05_ok
	dw ut_test05_nok
	dw outer_quit

ut_test05:
	mov bx, word [current_sector]
	cmp bx, expected_05
	je test_05_equal
	mov bx, 0
	jmp test_05_end
test_05_equal:
	mov bx, 1
test_05_end:
	NEXT

ut_test05_nok:
	puts nsuite
	puts ntest05
	puts nko2
	jmp ut_result05
	ret

ut_test05_ok:
	puts nsuite
	puts ntest05
	puts nok2
ut_result05:
	puts nexpected
	putw expected_05
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 06

ntest06:	db "tst_200_next_10;", "$"



ut_interp_test06:
	mov si, ut_thread06
	NEXT
ut_thread06:
	dw ut_lit, 200
	dw set_current
	dw outer_next_10
	dw ut_test06
	dw prim_skip_zero
	dw ut_test06_ok
	dw ut_test06_nok
	dw outer_quit

ut_test06:
	mov bx, word [current_sector]
	cmp bx, SCT_MIN
	je test_06_equal
	mov bx, 0
	jmp test_06_end
test_06_equal:
	mov bx, 1
test_06_end:
	NEXT

ut_test06_nok:
	puts nsuite
	puts ntest06
	puts nko2
	jmp ut_result06
	ret

ut_test06_ok:
	puts nsuite
	puts ntest06
	puts nok2
ut_result06:
	puts nexpected
	putw SCT_MIN
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 07

ntest07:	db "tst_190_next_10;", "$"



ut_interp_test07:
	mov si, ut_thread07
	NEXT
ut_thread07:
	dw ut_lit, SCT_MAX - 10
	dw set_current
	dw outer_next_10
	dw ut_test07
	dw prim_skip_zero
	dw ut_test07_ok
	dw ut_test07_nok
	dw outer_quit

ut_test07:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX
	je test_07_equal
	mov bx, 0
	jmp test_07_end
test_07_equal:
	mov bx, 1
test_07_end:
	NEXT

ut_test07_nok:
	puts nsuite
	puts ntest07
	puts nko2
	jmp ut_result07
	ret

ut_test07_ok:
	puts nsuite
	puts ntest07
	puts nok2
ut_result07:
	puts nexpected
	putw SCT_MAX
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 08

ntest08:	db "tst_191_next_10;", "$"

ut_interp_test08:
	mov si, ut_thread08
	NEXT
ut_thread08:
	dw ut_lit, SCT_MAX - 10 +1
	dw set_current
	dw outer_next_10
	dw ut_test08
	dw prim_skip_zero
	dw ut_test08_ok
	dw ut_test08_nok
	dw outer_quit

ut_test08:
	mov bx, word [current_sector]
	cmp bx, SCT_MIN
	je test_08_equal
	mov bx, 0
	jmp test_08_end
test_08_equal:
	mov bx, 1
test_08_end:
	NEXT

ut_test08_nok:
	puts nsuite
	puts ntest08
	puts nko2
	jmp ut_result08
	ret

ut_test08_ok:
	puts nsuite
	puts ntest08
	puts nok2
ut_result08:
	puts nexpected
	putw SCT_MIN
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 09

ntest09:	db "tst_199_next_1;", "$"

ut_interp_test09:
	mov si, ut_thread09
	NEXT
ut_thread09:
	dw ut_lit, SCT_MAX - 1
	dw set_current
	dw outer_next_sct
	dw ut_test09
	dw prim_skip_zero
	dw ut_test09_ok
	dw ut_test09_nok
	dw outer_quit

ut_test09:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX
	je test_09_equal
	mov bx, 0
	jmp test_09_end
test_09_equal:
	mov bx, 1
test_09_end:
	NEXT

ut_test09_nok:
	puts nsuite
	puts ntest09
	puts nko2
	jmp ut_result09
	ret

ut_test09_ok:
	puts nsuite
	puts ntest09
	puts nok2
ut_result09:
	puts nexpected
	putw SCT_MAX
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 13

ntest13:	db "tst_0_prev_1;", "$"


ut_interp_test13:
	mov si, ut_thread13
	NEXT
ut_thread13:
	dw ut_lit, 0
	dw set_current
	dw outer_prev_sct
	dw ut_test13
	dw prim_skip_zero
	dw ut_test13_ok
	dw ut_test13_nok
	dw outer_quit

ut_test13:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX
	je test_13_equal
	mov bx, 0
	jmp test_13_end
test_13_equal:
	mov bx, 1
test_13_end:
	NEXT

ut_test13_nok:
	puts nsuite
	puts ntest13
	puts nko2
	jmp ut_result13
	ret

ut_test13_ok:
	puts nsuite
	puts ntest13
	puts nok2
ut_result13:
	puts nexpected
	putw SCT_MAX
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 14

ntest14:	db "tst_200_prev_1;", "$"



ut_interp_test14:
	mov si, ut_thread14
	NEXT
ut_thread14:
	dw ut_lit, SCT_MAX
	dw set_current
	dw outer_prev_sct
	dw ut_test14
	dw prim_skip_zero
	dw ut_test14_ok
	dw ut_test14_nok
	dw outer_quit

ut_test14:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX - 1
	je test_14_equal
	mov bx, 0
	jmp test_14_end
test_14_equal:
	mov bx, 1
test_14_end:
	NEXT

ut_test14_nok:
	puts nsuite
	puts ntest14
	puts nko2
	jmp ut_result14
	ret

ut_test14_ok:
	puts nsuite
	puts ntest14
	puts nok2
ut_result14:
	puts nexpected
	putw SCT_MAX - 1
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 15

ntest15:	db "tst_200_prev_10;", "$"

expected_15	equ 190


ut_interp_test15:
	mov si, ut_thread15
	NEXT
ut_thread15:
	dw ut_lit, 200
	dw set_current
	dw outer_prev_10
	dw ut_test15
	dw prim_skip_zero
	dw ut_test15_ok
	dw ut_test15_nok
	dw outer_quit

ut_test15:
	mov bx, word [current_sector]
	cmp bx, expected_15
	je test_15_equal
	mov bx, 0
	jmp test_15_end
test_15_equal:
	mov bx, 1
test_15_end:
	NEXT

ut_test15_nok:
	puts nsuite
	puts ntest15
	puts nko2
	jmp ut_result15
	ret

ut_test15_ok:
	puts nsuite
	puts ntest15
	puts nok2
ut_result15:
	puts nexpected
	putw expected_15
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 16

ntest16:	db "tst_11_prev_10;", "$"

expected_16	equ 1


ut_interp_test16:
	mov si, ut_thread16
	NEXT
ut_thread16:
	dw ut_lit, 11
	dw set_current
	dw outer_prev_10
	dw ut_test16
	dw prim_skip_zero
	dw ut_test16_ok
	dw ut_test16_nok
	dw outer_quit

ut_test16:
	mov bx, word [current_sector]
	cmp bx, expected_16
	je test_16_equal
	mov bx, 0
	jmp test_16_end
test_16_equal:
	mov bx, 1
test_16_end:
	NEXT

ut_test16_nok:
	puts nsuite
	puts ntest16
	puts nko2
	jmp ut_result16
	ret

ut_test16_ok:
	puts nsuite
	puts ntest16
	puts nok2
ut_result16:
	puts nexpected
	putw expected_16
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 17

ntest17:	db "tst_10_prev_10;", "$"

ut_interp_test17:
	mov si, ut_thread17
	NEXT
ut_thread17:
	dw ut_lit, 10
	dw set_current
	dw outer_prev_10
	dw ut_test17
	dw prim_skip_zero
	dw ut_test17_ok
	dw ut_test17_nok
	dw outer_quit

ut_test17:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX
	je test_17_equal
	mov bx, 0
	jmp test_17_end
test_17_equal:
	mov bx, 1
test_17_end:
	NEXT

ut_test17_nok:
	puts nsuite
	puts ntest17
	puts nko2
	jmp ut_result17
	ret

ut_test17_ok:
	puts nsuite
	puts ntest17
	puts nok2
ut_result17:
	puts nexpected
	putw SCT_MAX
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 18

ntest18:	db "tst_SCT_MIN_prev_10;", "$"

ut_interp_test18:
	mov si, ut_thread18
	NEXT
ut_thread18:
	dw ut_lit, SCT_MIN
	dw set_current
	dw outer_prev_10
	dw ut_test18
	dw prim_skip_zero
	dw ut_test18_ok
	dw ut_test18_nok
	dw outer_quit

ut_test18:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX
	je test_18_equal
	mov bx, 0
	jmp test_18_end
test_18_equal:
	mov bx, 1
test_18_end:
	NEXT

ut_test18_nok:
	puts nsuite
	puts ntest18
	puts nko2
	jmp ut_result18
	ret

ut_test18_ok:
	puts nsuite
	puts ntest18
	puts nok2
ut_result18:
	puts nexpected
	putw SCT_MAX
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 19

ntest19:	db "tst_SCT_MIN_prev_1;", "$"

ut_interp_test19:
	mov si, ut_thread19
	NEXT
ut_thread19:
	dw ut_lit, SCT_MIN
	dw set_current
	dw outer_prev_sct
	dw ut_test19
	dw prim_skip_zero
	dw ut_test19_ok
	dw ut_test19_nok
	dw outer_quit

ut_test19:
	mov bx, word [current_sector]
	cmp bx, SCT_MAX
	je test_19_equal
	mov bx, 0
	jmp test_19_end
test_19_equal:
	mov bx, 1
test_19_end:
	NEXT

ut_test19_nok:
	puts nsuite
	puts ntest19
	puts nko2
	jmp ut_result19
	ret

ut_test19_ok:
	puts nsuite
	puts ntest19
	puts nok2
ut_result19:
	puts nexpected
	putw SCT_MAX
	puts nobtained
	putw word[current_sector]
	puts ncrlf2
	ret


;-----------------------------------------------------------------------------
;

set_current:
	mov word [current_sector], bx
	NEXT

ut_lit:
	lodsw
	mov bx, ax
	NEXT



one_tos:
	mov bx, 1
	NEXT
raz_tos:
	mov bx, 0
	NEXT

nko2:	db "Ko;","$"
nok2:	db "Ok;","$"

tst_raz:
	mov bx, 0
	mov word [nbr], bx
	NEXT

tst_inc:
	mov bx, word [nbr]
	inc bx
	mov word [nbr], bx
	NEXT

tst_expected equ 1

tst_comp:
	mov bx, 0
	mov ax, word [nbr]
	cmp ax, tst_expected
	je tst_fin
	mov bx, 1
tst_fin:
	NEXT

	


%include "picotable.inc"
%include "picoforth.inc"
%include "fakehw.inc"
