%include "unit.inc"

BUF_ADR equ	0x0A00

%include "picoforth.mac"

test_suite:
	call ut_interp_test1
	call ut_interp_test2
	call ut_interp_test3
	call ut_interp_test4
	call ut_interp_test5
	call ut_interp_test6
	call ut_interp_test7
	call ut_interp_test8
	call ut_interp_test9
	call ut_interp_test0A
	call ut_interp_test0B
	call ut_interp_test0C
	call ut_interp_test0D
	call ut_interp_test0E
	call ut_interp_test0F

	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "ts_seq;", "$"
ncrlf2:		db 13, 10, "$"

nbr:	dw 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test 1

ntest:		db "tstseq;", "$"

ut_interp_test1:
	call ut_do_test1
	puts nsuite
	puts ntest
	mov bx, tst_expected
	mov ax, word[nbr]
	cmp bx, ax
	je test1_ok
	puts nko
	jmp test1_next
test1_ok:
	puts nok
test1_next:
	puts nexpected
	putw tst_expected
	puts nobtained
	putw word [nbr]
	puts ncrlf2
	ret


ut_do_test1:
	mov si, ut_thread
	NEXT
ut_thread:
	dw tst_raz
	dw tst_inc
	dw outer_quit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test2

tst_expected2	equ 2

ntest2:		db "tstseq2;", "$"

ut_interp_test2:
	call ut_do_test2
	puts nsuite
	puts ntest2
	mov bx, tst_expected2
	mov ax, word[nbr]
	cmp bx, ax
	je test2_ok
	puts nko
	jmp test1_next
test2_ok:
	puts nok
test2_next:
	puts nexpected
	putw tst_expected2
	puts nobtained
	putw word [nbr]
	puts ncrlf2
	ret

ut_do_test2:
	mov si, ut_thread2
	NEXT
ut_thread2:
	dw tst_raz
	dw tst_inc
	dw tst_inc
	dw outer_quit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 3

ntest3:		db "prim_jz with TOS=0;","$"

ut_interp_test3:
	call ut_do_test3
	ret

ut_do_test3:
	mov si, ut_thread3
	NEXT
ut_thread3:
	dw raz_tos
	dw prim_jz, ut3_Ok
	dw ut3_Failure
ut3_Ok:
	dw ut3_Succeed
	dw outer_quit
	ret

ut3_Failure:
	puts nsuite
	puts ntest3
	puts nko2
	puts ncrlf2
	ret

ut3_Succeed:
	puts nsuite
	puts ntest3
	puts nok2
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 4

ntest4:		db "prim_jz with TOS!=0;","$"

ut_interp_test4:
	call ut_do_test4
	ret

ut_do_test4:
	mov si, ut_thread4
	NEXT
ut_thread4:
	dw one_tos
	dw prim_jz, ut4_ko
	dw ut4_Succeed
	dw outer_quit
ut4_ko:
	dw ut4_Failure
	dw outer_quit


ut4_Failure:
	puts nsuite
	puts ntest4
	puts nko2
	puts ncrlf2
	ret

ut4_Succeed:
	puts nsuite
	puts ntest4
	puts nok2
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 5

ntest5:		db "prim_jmp Should pass;","$"

ut_interp_test5:
	call ut_do_test5
	ret

ut_do_test5:
	mov si, ut_thread5
	NEXT
ut_thread5:
	dw prim_jmp, ut5_jmp
	dw ut5_Failure
	dw outer_quit
ut5_jmp:
	dw ut5_Succeed
	dw outer_quit


ut5_Failure:
	puts nsuite
	puts ntest5
	puts nko2
	puts ncrlf2
	ret

ut5_Succeed:
	puts nsuite
	puts ntest5
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 6

ntest6:		db "prim_jz with bx=0;","$"

ut_interp_test6:
	call ut_do_test6
	ret

ut_do_test6:
	mov si, ut_thread6
	NEXT
ut_thread6:
	dw raz_tos
	dw prim_jz, ut6_jmp
	dw ut6_Failure
	dw outer_quit
ut6_jmp:
	dw ut6_Succeed
	dw outer_quit


ut6_Failure:
	puts nsuite
	puts ntest6
	puts nko2
	puts ncrlf2
	ret

ut6_Succeed:
	puts nsuite
	puts ntest6
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 7

ntest7:		db "prim_jz with bx=1;","$"

ut_interp_test7:
	call ut_do_test7
	ret

ut_do_test7:
	mov si, ut_thread7
	NEXT
ut_thread7:
	dw one_tos
	dw prim_jz, ut7_jmp
	dw ut7_Succeed
	dw outer_quit
ut7_jmp:
	dw ut7_Failure
	dw outer_quit


ut7_Failure:
	puts nsuite
	puts ntest7
	puts nko2
	puts ncrlf2
	ret

ut7_Succeed:
	puts nsuite
	puts ntest7
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 8

ntest8:		db "prim_lit with arg=1;","$"
ut8_kexpected	equ 1

ut_interp_test8:
	call ut_do_test8
	ret

ut_do_test8:
	mov si, ut_thread8
	NEXT
ut_thread8:
	dw ut_lit, ut8_kexpected
	dw ut8_test_tos
	dw prim_jz, ut8_Ok
	dw ut8_Failure
ut8_Ok:
	dw ut8_Succeed
	dw outer_quit

ut8_test_tos:
	mov cx, bx
	cmp bx, ut8_kexpected
	je ut8_testok
	mov bx, 1
	NEXT
ut8_testok:
	mov bx, 0
	NEXT

ut8_Failure:
	puts nsuite
	puts ntest8
	puts nko2
	puts nexpected

	jmp ut8_result

ut8_Succeed:
	puts nsuite
	puts ntest8
	puts nok2
ut8_result:
	puts nexpected
	putw ut8_kexpected
	puts nobtained
	putw cx
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 9

ntest9:		db "prim_lit with arg=0;","$"
ut9_kexpected	equ 0

ut_interp_test9:
	call ut_do_test9
	ret

ut_do_test9:
	mov si, ut_thread9
	NEXT
ut_thread9:
	dw ut_lit, ut9_kexpected
	dw ut9_test_tos
	dw prim_jz, ut9_Ok
	dw ut9_Failure
ut9_Ok:
	dw ut9_Succeed
	dw outer_quit

ut9_test_tos:
	mov cx, bx
	cmp bx, ut9_kexpected
	je ut9_testok
	mov bx, 1
	NEXT
ut9_testok:
	mov bx, 0
	NEXT

ut9_Failure:
	puts nsuite
	puts ntest9
	puts nko2
	puts nexpected

	jmp ut9_result

ut9_Succeed:
	puts nsuite
	puts ntest9
	puts nok2
ut9_result:
	puts nexpected
	putw ut9_kexpected
	puts nobtained
	putw cx
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 0A

ntest0A:		db "prim_skip_zero with tos==0;","$"
ut0A_kexpected	equ 0

ut_interp_test0A:
	call ut_do_test0A
	ret

ut_do_test0A:
	mov si, ut_thread0A
	NEXT
ut_thread0A:
	dw ut_lit, 0
	dw prim_skip_zero
	dw ut0A_Failure
	dw ut0A_Succeed
	dw outer_quit

ut0A_Failure:
	puts nsuite
	puts ntest0A
	puts nko2
	puts ncrlf2
	ret

ut0A_Succeed:
	puts nsuite
	puts ntest0A
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 0B

ntest0B:		db "prim_skip_zero with tos!=0;","$"


ut_interp_test0B:
	call ut_do_test0B
	ret

ut_do_test0B:
	mov si, ut_thread0B
	NEXT
ut_thread0B:
	dw ut_lit, 1
	dw prim_skip_zero
	dw ut0B_Succeed
	dw ut0B_Failure
	dw outer_quit

ut0B_Failure:
	puts nsuite
	puts ntest0B
	puts nko2
	puts ncrlf2
	ret

ut0B_Succeed:
	puts nsuite
	puts ntest0B
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 0C

ntest0C:		db "prim_skip_nzero with tos==0;","$"


ut_interp_test0C:
	call ut_do_test0C
	ret

ut_do_test0C:
	mov si, ut_thread0C
	NEXT
ut_thread0C:
	dw ut_lit, 0
	dw prim_skip_nzero
	dw ut0C_Succeed
	dw ut0C_Failure
	dw outer_quit

ut0C_Failure:
	puts nsuite
	puts ntest0C
	puts nko2
	puts ncrlf2
	ret

ut0C_Succeed:
	puts nsuite
	puts ntest0C
	puts nok2
	puts ncrlf2
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 0D

ntest0D:		db "prim_skip_nzero with tos!=0;","$"


ut_interp_test0D:
	call ut_do_test0D
	ret

ut_do_test0D:
	mov si, ut_thread0D
	NEXT
ut_thread0D:
	dw ut_lit, 1
	dw prim_skip_nzero
	dw ut0D_Failure
	dw ut0D_Succeed
	dw outer_quit

ut0D_Failure:
	puts nsuite
	puts ntest0D
	puts nko2
	puts ncrlf2
	ret

ut0D_Succeed:
	puts nsuite
	puts ntest0D
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 0E

ntest0E:		db "inner_execute check called is executed;","$"


ut_interp_test0E:
	call ut_do_test0E
	ret

ut_do_test0E:
	mov si, ut_thread0E
	NEXT
ut_thread0E:
	dw ut_lit, ut0E_Succeed
	dw inner_execute
	dw ut0E_Failure
	dw outer_quit

ut0E_Failure:
	puts nsuite
	puts ntest0E
	puts nko2
	puts ncrlf2
	ret

ut0E_Succeed:
	puts nsuite
	puts ntest0E
	puts nok2
	puts ncrlf2
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test 0F

ntest0F:		db "inner_execute check return is ok;","$"


ut_interp_test0F:
	call ut_do_test0F
	ret

ut_do_test0F:
	mov si, ut_thread0F
	NEXT
ut_thread0F:
	dw ut_lit, ut0F_Succeed
	dw inner_execute, do_something
	dw ut0F_Succeed
	dw outer_quit

do_something:
	NEXT

ut0F_Failure:
	puts nsuite
	puts ntest0F
	puts nko2
	puts ncrlf2
	ret

ut0F_Succeed:
	puts nsuite
	puts ntest0F
	puts nok2
	puts ncrlf2
	ret






ut_lit:
	lodsw
	mov bx, ax
	NEXT



one_tos:
	mov bx, 1
	NEXT
raz_tos:
	mov bx, 0
	NEXT

nko2:	db "Ko;","$"
nok2:	db "Ok;","$"

tst_raz:
	mov bx, 0
	mov word [nbr], bx
	NEXT

tst_inc:
	mov bx, word [nbr]
	inc bx
	mov word [nbr], bx
	NEXT

tst_expected equ 1

tst_comp:
	mov bx, 0
	mov ax, word [nbr]
	cmp ax, tst_expected
	je tst_fin
	mov bx, 1
tst_fin:
	NEXT

;-----------------------------------------------------------------------------
;

%include "picotable.inc"
%include "picoforth.inc"
%include "fakehw.inc"

