%include "unit.inc"

BUF_ADR equ	0x0A00

%macro ENTER 0
	nop
%endmacro

%macro LEAVE 0
	ret
%endmacro

%macro NEXT 0
	ret
%endmacro


test_suite:
	call ut_find_zero
	call ut_find_c
	call ut_find_p
	call ut_find_n

	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "ts_find;","$"


nFind_z:	db "ut_find_z should pass;","$"
nFind_c:	db "ut_find_c should pass;","$"
nFind_p:	db "ut_find_p should pass;","$"
nFind_n:	db "ut_find_n should pass;","$"

ts_find_zero_EXPECTED equ 0


ut_find_zero:
	puts nsuite
	puts nFind_z
	
	mov DI, ts_find_zero_EXPECTED
	mov bl, "z"
	mov cx, nFind_z
	call do_find_pass
	ret

ut_find_c:
	puts nsuite
	puts nFind_c
	
	mov DI, label_c
	mov bl, "c"
	mov cx, nFind_c
	call do_find_pass
	ret

ut_find_p:
	puts nsuite
	puts nFind_p
	
	mov DI, label_p
	mov bl, "p"
	mov cx, nFind_p
	call do_find_pass
	ret

ut_find_n:
	puts nsuite
	puts nFind_n
	
	mov DI, label_n
	mov bl, "n"
	mov cx, nFind_n
	call do_find_pass
	ret

do_find_pass:

	call inner_find
	
	cmp BX, di
	je ts_pass_ok
	puts nko
	puts nfail
	jmp ts_pass_end
ts_pass_ok:
	puts nok
	puts npass
ts_pass_end:
	puts nexpected
	putw di
	puts nobtained
	putw BX
	puts ncrlf
	ret

do_find_fail:
	
	call inner_find
	
	cmp BX, di
	je ts_fail_ok
	puts nok
	puts nfail
	jmp ts_fail_end
ts_fail_ok:
	puts nko
	puts npass
ts_fail_end:
	puts nexpected
	putw DI
	puts nobtained
	putw BX
	puts ncrlf
	ret
	
	
cmd_table:
	db "c"
	dw label_c
	db "p"
	dw label_p
	db "n"
	dw label_n
	db END


label_c: nop
label_p: nop
label_n: nop


%include "picoforth.inc"
%include "picohw.inc"
